%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jacobs Landscape Poster
% LaTeX Template
% Version 1.1 (14/06/14)
%
% Created by
% Computational Physics and Biophysics Group, Jacobs University
% https://teamwork.jacobs-university.de:8443/confluence/display/CoPandBiG/LaTeX+Poster
%
% Further modified by
% Nathaniel Johnston (nahaniel@njohnston.ca)
%
% This template has been downloaded from:
% http://www.LaTeXTemplates.com
%
% License
% CC BY-NC-SA 3.0 (http://creativecommon.org/licensesby-nc-sa/3.0/)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%---------------------------------------------------------------------------------------
%	PACKAGES AND OTHER DOCUMENT CONFIGURATION
%----------------------------------------------------------------------------------------

\documentclass[final]{beamer}

\usepackage[scale=0.8]{beamerposter} % Use the beamerposter package for laying out the poster

\usetheme{confposter} % Use the confposter theme supplied with this template

\setbeamercolor{block title}{fg=ngreen,bg=white} % Colors of the block titles
\setbeamercolor{block body}{fg=black,bg=white} % Colors of the body of blocks
\setbeamercolor{block alerted title}{fg=white,bg=dblue!70} % Colors of the highlighted block titles
\setbeamercolor{block alerted body}{fg=black,bg=dblue!10} % Colors of the body of highlighted blocks
% Many more colors are available for use in beamerthemeconfposter.sty

%-----------------------------------------------------------
% Define the column widths and overall poster size
% To set effective sepwid, onecolwid and twocolwid values, first choose how many columns you want and how much separation you want between columns
% In this template, the separation width chosen is 0.024 of the paper width and a 4-column layout
% onecolwid should therefore be (1-(# of columns+1)*sepwid)/# of columns e.g. (1-(4+1)*0.024)/4 = 0.22
% Set twocolwid to be (2*onecolwid)+sepwid = 0.464
% Set threecolwid to be (3*onecolwid)+2*sepwid = 0.708

\newlength{\sepwid}
\newlength{\onecolwid}
\newlength{\twocolwid}
\newlength{\threecolwid}
\setlength{\paperwidth}{36in} % A0 width: 46.8in
\setlength{\paperheight}{24in} % A0 height: 33.1in
\setlength{\sepwid}{0.024\paperwidth} % Separation width (white space) between columns
\setlength{\onecolwid}{0.22\paperwidth} % Width of one column
\setlength{\twocolwid}{0.464\paperwidth} % Width of two columns
\setlength{\threecolwid}{0.708\paperwidth} % Width of three columns
\setlength{\topmargin}{-0.5in} % Reduce the top margin size
%-----------------------------------------------------------

\usepackage{graphicx}  % Required for including images

\usepackage{booktabs} % Top and bottom rules for tables

%----------------------------------------------------------------------------------------
%	TITLE SECTION
%----------------------------------------------------------------------------------------

\title{Dynamic loan default prediction} % Poster title

\author{Maxime Rivet, Marc Thibault, Mael Trean} % Author(s)

\institute{CS229, University of Stanford} % Institution(s)

%----------------------------------------------------------------------------------------

\begin{document}

\addtobeamertemplate{block end}{}{\vspace*{2ex}} % White space under blocks
\addtobeamertemplate{block alerted end}{}{\vspace*{2ex}} % White space under highlighted (alert) blocks

\setlength{\belowcaptionskip}{2ex} % White space under figures
\setlength\belowdisplayshortskip{2ex} % White space under equations

\begin{frame}[t] % The whole poster is enclosed in one beamer frame

\begin{columns}[t] % The whole poster consists of three major columns, the second of which is split into two columns twice - the [t] option aligns each column's content to the top

\begin{column}{\sepwid}\end{column} % Empty spacer column

\begin{column}{\onecolwid} % The second column within column 2 (column 2.2)
%----------------------------------------------------------------------------------------
%	OBJECTIVES
%----------------------------------------------------------------------------------------

% \begin{alertblock}{Objectives}

% Lorem ipsum dolor sit amet, consectetur, nunc tellus pulvinar tortor, commodo eleifend risus arcu sed odio:
% \begin{itemize}
% \item Mollis dignissim, magna augue tincidunt dolor, interdum vestibulum urna
% \item Sed aliquet luctus lectus, eget aliquet leo ullamcorper consequat. Vivamus eros sem, iaculis ut euismod non, sollicitudin vel orci.
% \item Nascetur ridiculus mus.
% \item Euismod non erat. Nam ultricies pellentesque nunc, ultrices volutpat nisl ultrices a.
% \end{itemize}

% \end{alertblock}

%----------------------------------------------------------------------------------------
%	INTRODUCTION
%----------------------------------------------------------------------------------------

\begin{block}{Motivation}
    Predicting the ouctome of a loan is a recurrent, crucial and difficult issue in insurance and banking.
    \vspace{5mm}

    The objective of our project is to predict whether a loan will default or not based on objective financial data only.
    \vspace{5mm}

    We used a dataset provided by LendingClub concerning almost 1 million loans issued between 2008 and 2017.
    \vspace{5mm}

    Since a default is far more costly for a loan issuer than a missed loan, we focused on maximizing the F-score as an evaluation metric for our algorithm.
    \vspace{5mm}

    Using a very structured pipeline to load and test algorithm, we reviewed most of the classification Machine Learning strategies to extract information from the very noisy data provided by LendingClub.

\end{block}

%------------------------------------------------
\begin{block}{Data}

It consists into approximately 800,000 samples of loans granted by the company, with the full set of informations about the borrower, the history of payments and the outcome of the loan.
\vspace{5mm}

The dataset is quite clean and the figures can be considered as ground truth, but lots of columns are either irrelevant, very sparse or non informative.
Moreover, the dataset is very unbalanced, with approximately 17\% of loans considered as defaulted.
\vspace{5mm}

Since the objective is to predict the outcome from the informations gathered at the signature of the loan, we cannot use the data concerning the history of payments or the current situation of a loan.
\vspace{5mm}

Excluding features for which the information is incomplete, or uninformative, we get a total of 19 features, that cover personal information (credit grade, income, housing status, ...) and credit information (amount, interest rates, ...).
\vspace{5mm}

Accuracy is not well-suited for our problem. The unbalance of the classes would lead an algorithm to never predict a default. $F1$-score allows us to quantify a good prediction on both precision and recall.

$$F_1=2\cdot\frac{\text{precision} \cdot \text{recall}}{\text{precision}+\text{recall}}$$

\end{block}

%----------------------------------------------------------------------------------------

\end{column} % End of the first column

\begin{column}{\sepwid}\end{column} % Empty spacer column

\begin{column}{\onecolwid} % Begin a column which is two columns wide (column 2)

%----------------------------------------------------------------------------------------
%	MATERIALS
%----------------------------------------------------------------------------------------

\begin{block}{Data exploration}

The dataset is not well separated, as this TSNE denotes. Also, the class unbalance is significant, and no clear separator appears.
\begin{center}
    \includegraphics[scale=0.65]{TSNE}
\end{center}

\end{block}

\begin{block}{Models}

The main models we used are:

\begin{itemize}
  \item Regularized Logistic Regression, from \texttt{sklearn}
  \item Gradient Boosting Decision Trees, from \texttt{xgboost}
\end{itemize}

Our approach consists in taking class unbalance into account when training our learning algorithm, with the three following methods:

\begin{itemize}
    \item Force a fixed class balance $p$ in the training set by resampling,
    \item Change the limit $\alpha$ above which the algorithm outputs 1 from the \texttt{predict\_proba}: $z_i = 1_{(y_i > \alpha)}$,
    \item Balance the loss function to penalize the midprediction of distinct classes differently: $L_i = \omega_1 \ y \ log(\hat{y}) + \omega_0 \ (1 - y) \ log(1 - \hat{y})$.
\end{itemize}

We then grid over the parameters of these methods:

\begin{itemize}
    \item fixed class occurrence ratio $p$,
    \item limit $\alpha$,
    \item penalization parameters $\omega_0, \omega_1$
\end{itemize}

We then optimize the $F$-score we obtain on the dev set, in order to make sure that we do not overfit.
\end{block}

\end{column} % End of the split of column 2 - any content after this will now take up 2 columns width


\begin{column}{\sepwid}\end{column} % Empty spacer column

\begin{column}{\onecolwid} % Begin a column which is two columns wide (column 2)
%----------------------------------------------------------------------------------------
%	METHODS
%----------------------------------------------------------------------------------------

\begin{block}{Individual classifiers results}
    Our three cross-validation methods yield significantly good results, beating the random choice on this extremely intricated dataset.

    \begin{center}
        \includegraphics[scale=0.5]{Balance}
    \end{center}
    We reach a $F$-score of 38\% by balancing classes upon training.
    \vspace{8mm}

    \begin{center}
        \includegraphics[scale=0.5]{Frontier}
    \end{center}
    We reach a $F$-score of 41\% by shifting the decision frontier.
    \vspace{8mm}

    \begin{center}
        \includegraphics[scale=0.5]{Weight}
    \end{center}
    We reach a $F$-score of 39\% by penalizing labels distinctively.
\end{block}


% %----------------------------------------------------------------------------------------
% %	IMPORTANT RESULT
% %----------------------------------------------------------------------------------------

% \begin{alertblock}{Important Result}

% Lorem ipsum dolor \textbf{sit amet}, consectetur adipiscing elit. Sed commodo molestie porta. Sed ultrices scelerisque sapien ac commodo. Donec ut volutpat elit.

% \end{alertblock}
\end{column} %
%----------------------------------------------------------------------------------------

\begin{column}{\sepwid}\end{column} % Empty spacer column

\begin{column}{\onecolwid} % Begin a column which is two columns wide (column 2)

%----------------------------------------------------------------------------------------
%	CONCLUSION
%----------------------------------------------------------------------------------------

\begin{block}{Combining classifiers }

  We added a regression of regressions approach, which consists in:

  \begin{itemize}
      \item Train several classifiers
      \item Output \texttt{predicted\_probability} for each sample and each classifier
      \item Run a second classifer with the outputs of individuals classifiers as features
  \end{itemize}

    The stacking of different models is also quite promising, since it allows to take advantage of the best classification possibilities of each model.
    \vspace{5mm}

    The results are better on test data, as we reach 43\% of $F$-score.

    \begin{center}
    \begin{tabular}{|l||c|c|}
        \hline
        Reality vs. Predicted  & Fully paid & Defaulted \\
        \hline
        Fully paid & 84,944 & 37,294 \\
        Defaulted & 12,032 & 18,092 \\
        \hline
      \end{tabular}
    \end{center}

\end{block}

\begin{block}{Further enhancements}
\begin{itemize}
    \item The exploration of the stacking of models sounds promising, and would probably be the best exploration axis if we had more time to spend on this project.

    \item Dynamic predictions by updating them when payments are due might allow a more precise risk management for the issuer. Time and status of payments can bring important insight in order to spot default risk
\end{itemize}
\end{block}

%----------------------------------------------------------------------------------------
%	ADDITIONAL INFORMATION
%----------------------------------------------------------------------------------------

% \begin{block}{Additional Information}

% Maecenas ultricies feugiat velit non mattis. Fusce tempus arcu id ligula varius dictum.
% \begin{itemize}
% \item Curabitur pellentesque dignissim
% \item Eu facilisis est tempus quis
% \item Duis porta consequat lorem
% \end{itemize}

% \end{block}

%----------------------------------------------------------------------------------------
%	REFERENCES
%----------------------------------------------------------------------------------------

\begin{block}{References}

\nocite{*} % Insert publications even if they are not cited in the poster
\small{\bibliographystyle{unsrt}
Introduction to stacking :

http://blog.kaggle.com/2016/12/27/a-kagglers-guide-to-model-stacking-in-practice/
\vspace{5mm}

Kaggle dataset and best preprocess :

https://www.kaggle.com/vincepota/predicting-customers-who-will-charge-off
\vspace{5mm}

Dealing with unbalanced datasets :

https://svds.com/learning-imbalanced-classes/

\bibliography{sample}\vspace{0.75in}}
\end{block}

%----------------------------------------------------------------------------------------
%	ACKNOWLEDGEMENTS
%----------------------------------------------------------------------------------------

% \setbeamercolor{block title}{fg=red,bg=white} % Change the block title color

% \begin{block}{Acknowledgements}

% \small{\rmfamily{Nam mollis tristique neque eu luctus. Suspendisse rutrum congue nisi sed convallis. Aenean id neque dolor. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.}} \\

% \end{block}

%----------------------------------------------------------------------------------------
%	CONTACT INFORMATION
%----------------------------------------------------------------------------------------

% \setbeamercolor{block alerted title}{fg=black,bg=norange} % Change the alert block title colors
% \setbeamercolor{block alerted body}{fg=black,bg=white} % Change the alert block body colors

% \begin{alertblock}{Contact Information}

% \begin{itemize}
% \item Web: \href{http://www.university.edu/smithlab}{http://www.university.edu/smithlab}
% \item Email: \href{mailto:john@smith.com}{john@smith.com}
% \item Phone: +1 (000) 111 1111
% \end{itemize}

% \end{alertblock}

% \begin{center}
% \begin{tabular}{ccc}
% \includegraphics[width=0.4\linewidth]{logo.png} & \hfill & \includegraphics[width=0.4\linewidth]{logo.png}
% \end{tabular}
% \end{center}

%----------------------------------------------------------------------------------------

\end{column} % End of the third column

\end{columns} % End of all the columns in the poster

\end{frame} % End of the enclosing frame

\end{document}
